﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.GridHelperClasses;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;

namespace DataGrid
{
    public partial class Form1 : Form
    {
        DataTable dt;
        public Form1()
        {
            InitializeComponent();

            this.gridGroupingControl1.ShowGroupDropArea = true;
            this.gridGroupingControl1.AllowProportionalColumnSizing = true;

            #region DataSource
            DataCollection dataSource = new DataCollection();
            Random rand = new Random();
            int r1 = rand.Next(1000);
            int r = rand.Next(100);
            for (int i = 0; i < 10; i++)
            {
                if (i >= 4 && i <= 6)
                {
                    dataSource.Add(new Data(i.ToString(), "" , "Desc" + r.ToString(), r.ToString() + "Data"));
                }
                else
                    dataSource.Add(new Data(i.ToString(), "" + r.ToString(), "Desc" + r.ToString(), r.ToString() + "Data"));
                r = rand.Next(100);
                r1 = rand.Next(1000);
            }
            this.gridGroupingControl1.DataSource = dataSource;
            dt = new DataTable();
            dt.Columns.Add("Name");
            dt.Columns.Add("Id");
            dt.Columns.Add("Amount", typeof(double));
            for (int i = 0; i < 500; i++)
            {
                DataRow dr = dt.NewRow();
                dr[0] = "E" + i.ToString(); 
                dr[1] = i;
                dr[2] = i;
                dt.Rows.Add(dr);
            }

            #endregion

            this.gridGroupingControl1.TopLevelGroupOptions.ShowFilterBar = true;
            foreach (GridColumnDescriptor desc in this.gridGroupingControl1.TableDescriptor.Columns)
            {
                desc.AllowFilter = true;
                //desc.FilterRowOptions.AllowCustomFilter = false;
                //desc.FilterRowOptions.AllowEmptyFilter = false;
            }

            GridDynamicFilter filter = new GridDynamicFilter();
            //filter.WireGrid(this.gridGroupingControl1);
            this.gridGroupingControl1.TableDescriptor.Columns["CategoryID"].Appearance.AnyRecordFieldCell.CellType = "ComboBox";
            this.gridGroupingControl1.TableDescriptor.Columns["CategoryID"].Appearance.AnyRecordFieldCell.DataSource = dt;
            this.gridGroupingControl1.TableDescriptor.Columns["CategoryID"].Appearance.AnyRecordFieldCell.DisplayMember = "Id";
            this.gridGroupingControl1.TableDescriptor.Columns["CategoryID"].Appearance.AnyRecordFieldCell.ValueMember = "Name";

            this.gridGroupingControl1.TableDescriptor.Columns["CategoryName"].Appearance.AnyRecordFieldCell.CellType = "ComboBox";
            this.gridGroupingControl1.TableDescriptor.Columns["CategoryName"].Appearance.AnyRecordFieldCell.DataSource = dt;
            this.gridGroupingControl1.TableDescriptor.Columns["CategoryName"].Appearance.AnyRecordFieldCell.DisplayMember = "Id";
            this.gridGroupingControl1.TableDescriptor.Columns["CategoryName"].Appearance.AnyRecordFieldCell.ValueMember = "Amount";

            //To add the FilterCondition
            FilterCondition condition = new FilterCondition((FilterCompareOperator.Like), "3");
            RecordFilterDescriptor recordFilter = new RecordFilterDescriptor("CategoryID", condition);

            // Add the RecordFilterDescriptor to the RecordFilters.
            this.gridGroupingControl1.TableDescriptor.RecordFilters.Add(recordFilter);

            this.gridGroupingControl1.QueryCellStyleInfo += GridGroupingControl1_QueryCellStyleInfo;
        }

        private void GridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            if (e.TableCellIdentity.Column == null)
                return;
            if(e.TableCellIdentity.DisplayElement.Kind == Syncfusion.Grouping.DisplayElementKind.Record)
            {
                if(e.Style.CellValue == null)
                {
                    e.Style.CellValue = string.Empty;
                }
            }
        }
    }
}
